#ifndef INC_GTCURSOR_H
#define INC_GTCURSOR_H

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>

#include "gtbase.h"
#include "gtdisplay.h"
#include "gtpixmap.h"
#include "gtfont.h"

/************************************************************************\
*
* GtCursor class header.
*
* $Ident: This file is part of the 'Gt-library' 1.0.0 $
* $Copyright: (C) 1997 by Gran Gustafsson $
*
\************************************************************************/


class GtCursor : public GtBase
{
public:
		/* Standard */
	GtCursor(void);
	void Destroy(void);
	void DeInit(void);
	sbool Init(GtDisplay *d,GtTag *tgs);
	sbool Init(GtTag *tgs);
	sbool Set(GtTag *tgs);
	void Get(GtTag *tgs);
	char *GetClass(void) { return("GtCursor"); }
	sbool IsSubClassOf(char *cn);
		/* Values */
	inline Cursor XCurs(void) { return(curs); }
		/* Friends */
	friend GtCursor *GtMkSharedCursor(GtDisplay *d,GtTag *tgs);
protected:
	GtCursor *next;
	GtDisplay *dsp;
	union
	{
		GtPixmap *pix;
		struct
		{
			GtFont *fnt;
			unsigned int ch;
		} f;
		unsigned int shape;
	} shp;
	union
	{
		GtPixmap *pix;
		struct
		{
			GtFont *fnt;
			unsigned int ch;
		} f;
	} msk;
	XColor fg,bg;
	Cursor curs;
	int cnt;
	ubyte type;
	sbool nofreex;
};

extern GtCursor *GtMkCursor(GtDisplay *d,GtTag *tgs);
extern GtCursor *GtMkCursor(GtDisplay *d,ulong tag,...);
extern GtCursor *GtMkSharedCursor(GtDisplay *d,GtTag *tgs);
extern GtCursor *GtMkSharedCursor(GtDisplay *d,ulong tag,...);

#endif /* INC_GTCURSOR_H */
